<?

function disp_tree(&$tree, $level = 0)
{
  global $PHP_SELF, $config;

  $dir = dirname ($PHP_SELF);
  $l1 = strlen ($dir);
  $l2 = strlen ($tree->rel_path);
  $len = ($l1 < $l2) ? $l1 : $l2;
  if (strncmp ($dir, $tree->rel_path, $len))
    return;

  if (!$level)
    echo '
  <table>';
  
  echo '
    <tr>';

  for ($i = 0; $i < $level; $i++)
    echo '<td></td>';

  $char = '-';
  if ($l1 == $l2) 
    $char ='*';
  if ($l1 > $l2)
    $char = '+';

  echo '<td>'.$char.'</td>
     <th colspan="42" align="left">
      <a href="'.$tree->rel_path.'">'.$config->translate ($tree->name).'</a>
     </th>';
  
  echo '
   </tr>';

  while (list ($key, $value) = each ($tree->childs))
    disp_tree ($value, $level + 1);

  if (!$level)
    echo '
  </table>
';
}

function disp_info ($name, $info, $attr = false)
{
  global $config;

  if ($attr)
    {
      $open = "<$attr>";
      $close = "</$attr>";
    }
  $open = "<td>".$open;
  $close = $close."</td>";

  echo '
      <tr>
       '.$open.'<b>'.$config->translate ($name).'</b>'.$close.'
       '.$open.':'.$close.'
       '.$open.$info.$close.'
      </tr>';
}

function make_view_form (&$photo)
{
  global $PHP_SELF;
  global $config;

  $default = $config->get ("photos", "def_reso");
  
  $res = '
<form action="'.$PHP_SELF.'" method="get">
 <input type="hidden" name="mode" value="view">
 <input type="hidden" name="file" value="'.basename ($photo->filename).'">
 <select name="reso">';
  $resos = split (" ", $config->get ("photos", "resolutions"));
  for ($i = 0; $i < count ($resos); $i++)
    {
      $x = $resos[$i];
      $y = (int) ((float) $x * 
		  ((float) $photo->sizey / (float) $photo->sizex));
      
      if ($photo->rotate % 2)
	$reso = $y.'x'.$x;
      else
	$reso = $x.'x'.$y;
      $res .= '
  <option value="'.$x.'"'.(($default == $x) ? ' selected' : '').'>'.$reso.'</option>';
    }
  $res .='
 </select>
 <input type="submit" value="OK">
</form>';
  return $res;
}

function disp_thumb (&$photo, $reso)
{
  global $config;

  echo '
    <td>
     <table>
      <tr>
       <td colspan="42" align="center"><img alt="" src="'.$photo->resize ($reso).'"></td>
      </tr>
      <tr>
       <th colspan="42">
        <form action="'.$PHP_SELF.'" method="get">
        '.$photo->name.' 
         <input type="hidden" name="mode" value="edit">
         <input type="hidden" name="reso" value="320">
         <input type="hidden" name="file" value="'.basename ($photo->filename).'">
         <input type="image" name="edit" src="'.
    $config->get ("general", "icon_dir").'/edit.png">
        </form>
       </th>
      </tr>';
  if ($photo->date)
    disp_info ("Date", strftime ($config->translate ("%d/%m/%Y - %H:%M"),
						     $photo->date), "small");
  if ($photo->rotate % 2)
    $reso = $photo->sizey.'x'.$photo->sizex;
  else
    $reso = $photo->sizex.'x'.$photo->sizey;
  disp_info ("Resolution", $reso, "small");
  disp_info ("View", make_view_form ($photo)); //, "small");
  
  echo '
     </table>
    </td>';
}

function human_size ($size)
{
  $qual = " KMGT";
  for ($i = 0; $size > 1024.0; $i++)
    $size /= 1024.0;
  for ($dec = 2, $thres = 10; ($size > $thres) && ($dec); $thres *= 10)
    $dec--;
  $size = number_format ($size, $dec);
  return $size . " " . $qual[$i];
}

function disp_node (&$tree)
{
  global $config;

  $tree->load_items ();
  
  reset ($tree->items);
  $nb = 0;
  $nbcol = $config->get ("thumbnails", "columns");
  $reso = $config->get ("thumbnails", "def_reso");

  echo '
  <table cellspacing="8">
   <tr><td></td></tr>';

  while (list ($key, $value) = each ($tree->items))
    {
      if ($value->type != "photo")
	continue;
      if (!$nb)
	echo '
  <tr><td colspan="42"><b>'.$config->translate ("Photos").': </b></td></tr>';

      if (($nb % $nbcol) == 0)
	echo '
   <tr>';
      $nb++;
      
      disp_thumb ($value, $reso);
 
      if (($nb % $nbcol) == 0)
	echo '
   </tr>';
    }


  $nb = 0;
  reset ($tree->items);
  while (list ($key, $value) = each ($tree->items))
    {
      if ($value->type == "photo")
	continue;
      if (!$nb)
	echo '
  <tr><td colspan="42"><b>'.$config->translate ("Other items").': </b></td></tr>';

      if (($nb % $nbcol) == 0)
	echo '
   <tr>';
      $nb++;

      $name = $tree->rel_path . '/' . basename ($value->filename);

      echo '     
    <td>
     <table>';
      if ($value->filename)
	disp_info ("File", 
		   '<a href="'.$name.'">'.basename ($value->filename).'</a>');
      if ($value->name)
	disp_info ("Name", $config->translate ($value->name), "small");
      if ($value->date)
	disp_info ("Date", strftime ($config->translate ("%d/%m/%Y - %H:%M"),
				     $value->date), "small");
      if ($value->size)
	disp_info ("Size", human_size ($value->size), "small");
      if ($value->comment)
	disp_info ("Comment", $config->translate ($value->comment),
		   "small");
      
      echo '
     </table>
    </td>';

      if (($nb % $nbcol) == 0)
	echo '
   </tr>';
    }

  echo '
  </table>';  
}


function &find_my_node (&$tree)
{
  global $PHP_SELF;
  
  $dir = dirname ($PHP_SELF);

  if ($tree->rel_path == $dir)
    return $tree;

  for ($i = 0; $i < count ($tree->childs); $i++)
    {
      $res =& find_my_node ($tree->childs[$i]);
      if ($res)
	return $res;
    }
  return false;
}

function disp_index($tree, $node)
{
  global $config;

  echo '
  <br><b>'.$config->translate ("Tree").': </b><br>';
  disp_tree ($tree);

  if (!$node)
    {
      $node =& $tree;
      echo $config->translate("Hum, well, we seem to be lost. Going back to home.")."<br>";
    }
  
  disp_node ($node);

}


function disp_photo($name, $resolution, $edit = false)
{
  global $config;
  global $PHP_SELF;
  $photo = new photo;
  $photo->set_photo($name);

  if ($edit)
    echo '
  <table>
   <tr>
    <td>';

  if ($resolution > $photo->sizex)
    $resolution = $photo->sizex;
  
  echo '
  <table>
   <tr>
    <td colspan="42" align="center"><img alt="" src="'.$photo->resize ($resolution).'"></td>
   </tr>
   <tr>
    <th colspan="42">'.$photo->name.'</th>
   </tr>';
  if ($photo->date)
    disp_info ("Date", strftime ($config->translate ("%d/%m/%Y - %H:%M"),
						     $photo->date));
  if ($photo->rotate % 2)
    $reso = $photo->sizey.'x'.$photo->sizex;
  else
    $reso = $photo->sizex.'x'.$photo->sizey;
  disp_info ("Resolution", $reso);
  disp_info ("View", make_view_form ($photo));

  if ($photo->comment)
    echo '
   <tr>
    <td colspan="42">'.$photo->comment.'</td>
   </tr>';
  
  echo '
  </table>';

  if ($edit)
    {
      echo '
    </td>
    <td>';
      disp_edit ($photo, $name, $resolution);
      echo '
    </td>
   </tr>
  </table>';
    }
}

?>
